#!/bin/bash

STATE="$3"

name="$(basename "$0" '.sh')"
config="/etc/${name}.conf"
script_dir="/usr/lib/${name}/script.d"

tag='keepalived'
facility='daemon'

exec > >(logger -p "$facility".info -t "$tag" -e --id="$$") 2> >(logger -p "$facility".err -t "$tag" -e --id="$$")

case "$STATE" in
  MASTER|BACKUP|FAULT)
    echo "$STATE" >/run/keepalived.state
    exit_status='0'
    while read -r script; do
      "$script_dir"/"$script" "$@"
      [ "${?:-0}" -le "$exit_status" ] || exit_status="$?"
    done < <(grep -Ev '^(#|$)' "$config")
    exit "$exit_status"
    ;;
  *)
    echo "Unknown state: ${STATE}"
    exit 1
    ;;
esac
